package test2;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class OwnershipTable extends HashMap<Person,Car> {
    
    private final Comparator<Person> byAge;

    public OwnershipTable() {
        this.byAge = new AgeComparator();
    }
        
    public List<Person> ownersByName() {
        List<Person> result = new ArrayList();
        result.addAll(this.keySet());
        Collections.sort(result);
        return result;
    }
    
    public List<Person> ownersByAge() {
        List<Person> result = new ArrayList();
        result.addAll(this.keySet());
        Collections.sort(result,byAge);
        return result;
    }
    
    public Set<Person> ownersOf(Car car) {
        Set<Person> result = new HashSet();
        for(Map.Entry<Person,Car> entry : this.entrySet()) {
            if (entry.getValue()==car) {
                result.add(entry.getKey());
            }
        }
        return result;
    }
    
}
