package test2;

import java.util.Objects;

public class Person implements Comparable {
    
    private final String name;
    private int age;
    private String occupation;

    public Person(String name, int age, String occupation) {
        this.name = name;
        this.age = age;
        this.occupation = occupation;
    }

    public String getName() {
        return name;
    }

    public int getAge() {
        return age;
    }

    public String getOccupation() {
        return occupation;
    }

    public void setAge(int age) {
        this.age = age;
    }

    public void setOccupation(String occupation) {
        this.occupation = occupation;
    }
    
    @Override
    public int compareTo(Object obj) {
        return this.name.compareTo(((Person) obj).name);
    }

    @Override
    public int hashCode() {
        int hash = 5;
        hash = 53 * hash + name.hashCode();
        hash = 53 * hash + this.age;
        hash = 53 * hash + Objects.hashCode(this.occupation);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        return obj != null && obj instanceof Person pObj 
                      && name.equals(pObj.name) 
                      && this.age==pObj.age 
                      && Objects.equals(this.occupation,pObj.occupation);
    }

    @Override
    public String toString() {
        return "Person{" + name + "," + age + "," + occupation + '}';
    } 

}
